---
title: PositionSensorVRDevice.getImmediateState()
slug: Web/API/PositionSensorVRDevice/getImmediateState
tags:
  - API
  - Experimental
  - Expérimental(2)
  - Method
  - Obsolete
  - PositionSensorVRDevice
  - Reference
  - Référence(2)
  - VR
  - Virtual Reality
  - WebVR
---
<p>{{obsolete_header()}}{{APIRef("WebVR API")}}{{SeeCompatTable}}</p>

<p>The <strong><code>getImmediateState()</code></strong> method of the {{domxref("VRDevice")}} interface returns the current instantaneous position sensor state. This is intended to only be used rarely, for certain special uses, for example sampling the immediate position of a hand orientation sensor — or at least it will be, in the future.</p>

<p>For most standard uses, you'll probably want to use {{domxref("PositionSensorVRDevice.getState")}} instead.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var myPositionstate = PositionSensorVRDevice.getImmediateState();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Returns">Returns</h3>

<p>A {{domxref("VRPositionState")}} object.</p>

<h2 id="Examples">Examples</h2>

<p>Our <a href="https://mdn.github.io/webvr-tests/positionsensorvrdevice/">positionsensorvrdevice</a> demo uses the WebVR API to update the view of a simple {{domxref("CanvasRenderingContext2D","2D canvas")}} scene on each frame of a {{domxref("window.requestAnimationFrame()","requestAnimationFrame")}} loop. The main function that updates the view data is as follows:</p>

<pre class="brush: js">function setView() {
  var posState = gPositionSensor.getImmediateState();
  if(posState.hasPosition) {
    posPara.textContent = 'Position: x' + roundToTwo(posState.position.x) + " y"
                                + roundToTwo(posState.position.y) + " z"
                                + roundToTwo(posState.position.z);
    xPos = -posState.position.x * WIDTH * 2;
    yPos = posState.position.y * HEIGHT * 2;
    if(-posState.position.z &gt; 0.01) {
      zPos = -posState.position.z;
    } else {
      zPos = 0.01;
    }
  }

  if(posState.hasOrientation) {
    orientPara.textContent = 'Orientation: x' + roundToTwo(posState.orientation.x) + " y"
                                + roundToTwo(posState.orientation.y) + " z"
                                + roundToTwo(posState.orientation.z);
    xOrient = posState.orientation.x * WIDTH;
    yOrient = -posState.orientation.y * HEIGHT * 2;
    zOrient = posState.orientation.z * 180;

  }
}</pre>

<p>Here we are grabbing a {{domxref("VRPositionState")}} object using <code>getImmediateState()</code> and storing it in <code>posState</code> (the actual live demo uses <code>getState()</code>, but both seem to do the same thing currently.) We then check to make sure that position and orientation info is present in the current frame using {{domxref("VRPositionState.hasPosition")}} and {{domxref("VRPositionState.hasOrientation")}} (these return <code>null</code> if, for example the head mounted display is turned off or not pointing at the position sensor, which would cause an error.)</p>

<p>We then output the x, y and z position and orientation values for informational purposes, and use those values to update the <code>xPos</code>, <code>yPos</code>, <code>zPos, </code><code>xOrient</code>, <code>yOrient</code>, and <code>zOrient</code> variables, which are used to update the scene rendering on each frame.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PositionSensorVRDevice.getImmediateState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a>.</li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
